/* Tools for plotting the progress of {bbopt.h} routines */
/* Last edited on 2007-12-26 18:04:19 by stolfi */

#ifndef bbplot_h
#define bbplot_h

#include <fbox.h>
#include <fboxlist.h>

#include <ia.h>
#include <bool.h>
#include <pswr.h>

PSStream *bbplot_new_stream
  ( bool_t epsfmt, 
    char *outName,
    char *title,
    Interval xr, 
    Interval yr,
    double hsize,
    double vsize,
    bool_t equal, 
    double *xsc,
    double *ysc
  );
  /* Opens the output plot file and initializes scales, captions, etc.
    If {epsfmt} is true, the stream consists of encapsulated
    Postscript figures called "{outname}-{NNNNNN}.eps". If {epsfmt} is
    false, the stream is a plain Postscript document called
    "{outname}.ps", with "letter" paper size. The effective plot area
    will be {hsize} by {vsize} (in pt) plus a margin of 4 pt all around.
    
    The procedure also stores in {*xsc} and {*ysc} two scale factors
    to be applied to the X and Y coordinates before calling the
    {pswr.h} plotting functions. The client plot window will contain
    the rectangle {((*xsc)*xr)  ((*ysc)*xr)}.
    
    If {equal} is true, the scales {xsc,ysc} will be set so that the
    total scales of the plot are equal; if {equal} is false, the
    scales are set so that the ranges {xr} and {yr} fully occupy
    the canvas area minus the margins. */

#endif
