/* Setting the IEEE rounding mode bits on an IBM PC: */

#define MCW_RC          0x0c00  /* 8087/80287 Rounding Control Mask */
#define     RC_CHOP     0x0c00  /*   chop               */
#define     RC_UP       0x0800  /*   up                 */
#define     RC_DOWN     0x0400  /*   down               */
#define     RC_NEAR     0x0000  /*   near               */

#define ROUND_DOWN  _control87(RC_DOWN, MCW_RC)
#define ROUND_UP    _control87(RC_UP,   MCW_RC)
#define ROUND_NEAR  _control87(RC_NEAR, MCW_RC)
#define ROUND_ZERO  _control87(RC_CHOP, MCW_RC)

void farmove(void *src, void *dst, unsigned long size);
  /* Copies $size$ bytes from $*src$ to $*dst$. */

void farmove(void *src, void *dst, unsigned long size)
  {
    if(size > 65535L)
      { error ("farmove: too many bytes"); }
    memcpy((char *) dst, (char *) src, size);
  }

Interval foix_f_add  (Float x, Float y)
Interval foix_f_sub  (Float x, Float y)
Interval foix_f_mul  (Float x, Float y)

Interval foix_f_neg  (Float x)
Interval foix_f_sqr  (Float x)
Interval foix_f_inv  (Float x)
Interval foix_f_sqrt (Float x)

Interval foix_f_add(Interval x, Interval y)
  { return (iv_add(iv_const(x,Zero), iv_const(y,Zero))); }

Interval foix_f_sub(Interval x, Interval y)
  { return (iv_sub(iv_const(x,Zero), iv_const(y,Zero))); }

Interval foix_f_mul(Interval x, Interval y)
  { return (iv_mul(iv_const(x,Zero), iv_const(y,Zero))); }

Interval foix_f_neg(Interval x)
  { return (iv_neg(-x,Zero)); }

Interval foix_f_sqr(Interval x)
  { return (iv_sqr(iv_const(x,Zero))); }

Interval foix_f_inv(Interval x)
  { return (iv_inv(iv_const(x,Zero))); }

Interval foix_f_sqrt(Interval x)
  { return (iv_sqrt(iv_const(x,Zero))); }

#define eps_hmin (1.25 * 72.0)
#define eps_hmax (7.25 * 72.0)
#define eps_vmin (3.50 * 72.0)
#define eps_vmax (9.50 * 72.0)

