/* See {vec_sub.h}. */
/* Last edited on 2008-02-23 09:14:18 by stolfi */

#include <stdlib.h>
#include <stdint.h>

#include <bool.h>
#include <ref.h>
#include <vec.h>
#include <vec_sub.h>
 
vec_t *vec_cast_ref(void *v)
  { return (vec_t *)v; }

vec_sub_t vec_as_sub(vec_t *v)
  { vec_sub_t vs;
    vs.nel = v->nel; vs.el = v->el; vs.step = 1;
    return vs;
  }
    
vec_sub_t vec_sub(vec_sub_t *vs, uint32_t start, int step, uint32_t nel, size_t elsz)
  { vec_sub_t rs;
    demand(step != 0, "step cannot be zero");
    if (start >= vs->nel)
      { rs.nel = 0; }
    else
      { int maxnel = (step > 0 ? (vs->nel - start)/step : (start-1)/(-step) + 1);
        rs.nel = (nel <= maxnel ? nel : maxnel);
      }
    if (rs.nel == 0) 
      { rs.el = NULL; rs.step = 1; }
    else
      { rs.el = (void *)((char *)vs->el + elsz*(start*vs->step));
        rs.step = step*vs->step;
      }
    return rs;
  }
