/* Last edited on 2007-10-15 03:16:50 by stolfi */

    /* Remove the mean value {fm} from {fs,ft,fu}: */
    fs -= fm; ft -= fm; fu -= fm;
    /* Compute min {fh} s.t. {(fm,fm,fm)+(fs,ft,fu)/fh} is not OK: */
    double fh;
    if ((fm > 0.9999) || (fm < 0.0001))
      { fh = 1.0; }
    else
      { double L;
        fh = 0.0;
        L = (fs < 0 ? 0 : 1) - fm; if (fs*fs > fh*L*fs) { fh = fs/L; }
        L = (ft < 0 ? 0 : 1) - fm; if (ft*ft > fh*L*ft) { fh = ft/L; }
        L = (fu < 0 ? 0 : 1) - fm; if (fu*fu > fh*L*fu) { fh = fu/L; }
      }


bool debugtri = FALSE;

bool near_miss(double vStart, double vStep, double f, int k);

bool near_miss(double vStart, double vStep, double f, int k)
  { int i;
    for (i = k-2; i <= k+2; i++)
      { if (fabs(f - pswr_level(vStart, vStep, k)) < 1.0e-6) { return TRUE; }
      }
    return FALSE;
  }


    debugtri = near_miss(vStart, vStep, fMin, iMin) || near_miss(vStart, vStep, fMax, iMax);
    if (debugtri)
      { fprintf(stderr, "fMin = %24.15e iMin = %d", fMin, iMin); 
        fprintf(stderr, "  fMax = %24.15e iMax = %d\n", fMax, iMax); 
      }
      
    debugtri = near_miss(vStart, vStep, fMin, iMin) || near_miss(vStart, vStep, fMax, iMax);
    if (debugtri)
      { fprintf(stderr, "fMin = %24.15e iMin = %d", fMin, iMin); 
        fprintf(stderr, "  fMax = %24.15e iMax = %d\n", fMax, iMax); 
      }


----------------------------------------------------------------------
PSWriter *pswr_from_file(FILE *psfile);
  /* Creates a new PSWriter record for file {psfile}.
    Be sure to call pswr_begin_figure or pswr_begin_document
    to initialize it, and pswr_end_figure or pswr_end_document
    to finalize it. */

void pswr_delete(PSWriter *pswr);
  /* Reclaims the PSWriter record  {*pswr}. 
    Assumes that it has been properly finalized. */



----------------------------------------------------------------------
double SOPlot_Brightness(Color *C);
  /* The relative brightness (luminance) of color {C},
    namely {0.299 * R + 0.587 * G + 0.114 * B}. */

Color SOPlot_ColorScale(double s, Color *A, Color *B);
  /* Returns a color that lies {s} of the way from color {A} 
    to color {B}.  Assumes that the distance between two 
    colors is proportional to the difference in their brightnesses.  */
    
Color SOPlot_InterpolateColor
  ( double f,         /* Function value */
    double fPlotMin,  /* Minimum function value. */
    Color *CMin,      /* Color to use for {fPlotMin}. */
    bool clipMin,     /* TRUE maps values below {fPlotMin} to invisible. */
    double fPlotMax,  /* Maximum function value. */
    Color *CMax,      /* Color to use for {fPlotMax}. */
    bool clipMax      /* TRUE maps values above {fPlotMax} to invisible. */
  );
  /* Compute the color corresponding to {f}, by linear
    interpolation from {[fPlotMin _ fPlotMax]} to {[CMin _ CMax]}.
    The meaning of {clipMin} and {clipMax} is the same as
    in {SOPlot_PaintValues}. */

Color SOPlot_ClipColor(Color *C);
  /* Clips the color {C} to the unit cube, preserving 
    its brightness and hue. */

----------------------------------------------------------------------

    // DEBUG fprintf (stderr, "+InTriangle\n"); 



    /* Permute corners so that {fa <= fb <= fc}: */
    if( fa > fb )
      { temp = xb; xb = xa; xa = temp;      
        temp = yb; yb = ya; ya = temp;
        temp = fb; fb = fa; fa = temp;
      }
      
    if( fb > fc )
      { temp = xb; xb = xc; xc = temp;
        temp = yb; yb = yc; yc = temp;
        temp = fb; fb = fc; fc = temp; 
      }
      
    if( fa > fb )
      { temp = xb; xb = xa; xa = temp;      
        temp = yb; yb = ya; ya = temp;
        temp = fb; fb = fa; fa = temp;
      }


----------------------------------------------------------------------
void ps_draw_zero_line_in_triangle
  ( FILE *psfile,
    double xa, double ya, double fa,
    double xb, double yb, double fb,
    double xc, double yc, double fc
  )
  { assert(fa <= fb , "sort error(fa,*fb)");
    assert(fb <= fc , "sort error(fb,*fc)");
    
    /* If the zero set is empty or a single point, skip: */
    if ((fa >= 0.0) && (fb > 0.0)) { return; }
    if ((fc <= 0.0) && (fb < 0.0)) { return; }
    
    /* Find {f = 0} point {u} on polygonal {a--b--c}: */
    double xu, yu
    if (fb < 0.0) 
      { double s_bc = fc/(fc - fb);
        double s_cb = fb/(fb - fc);
        xu = xb*s_bc + xc*s_cb;
        yu = yb*s_bc + yc*s_cb;
      }
    else if (fb > 0.0) 
      { double s_ba = fa/(fa - fb);
        double s_ab = fb/(fb - fa);
        xu = xb*s_ba + xa*s_ab;
        yu = yb*s_ba + ya*s_ab;
      }
    else 
      { bool za = (fa == 0.0), zc = (fc == 0.0);
        if (za) { ps_draw_segment(psfile, xa, ya, xb, yb); }
        if (zc) { ps_draw_segment(psfile, xb, yb, xc, yc); }
        if (za && zc) { ps_draw_segment(psfile, xa, ya, xc, yc); }
        if (za || zc) { return; }
        xu = xb; yu = yb;
      }

    /* Find {f = 0} point {v} on side {a--c}: */
    double xv, yv;
    { double s_ca = fa/(fa - fc);
      double s_ac = fc/(fc - fa);
      xv = xc*s_ca + xa*s_ac;
      yv = yc*s_ca + ya*s_ac;
    }
    
    /* Draw segment {u--v}: */
    ps_draw_segment(psfile, xu, yu, xv, yv);
  }
----------------------------------------------------------------------
int ps_find_level(double z, int n, double *f)
  {
    int k;
    if (n == 0) 
      { k = 0; }
    else if (z <= f[0])
      { k = 0; }
    else if (f[n-1] < z)
      { k = n; }
    else 
      { /* Answer is in {1..n-1}. Try to use {*k} as hint. */
        int iInf = 0, iLim = n-1; 
        fprintf(stderr, "\n[%.3f=", z);
        
        /* Now narrow the interval by bisection or interpolation: */
        int iDif;
        while ((iDif = iLim - iInf) > 1)
          { /* Now {f[iInf] < z <= f[iLim]} hence {iInf < iLim}. */
            /* So the answer lies in {iInf+1..iLim}. */
            fprintf(stderr, "(%d:%d)", iInf,iLim);
           
            /* Use linear interpolation to narrow the interval {iInf+1..iLim}: */
            if (iDif >= 3)
              { /* Interpolate an index {iTry} in {iInf+1..iLim}: */
                int iTry;
                double r = (z - f[iInf])/(f[iLim] - f[iInf]);
                iTry = iInf + (int)(ceil(r*iDif));
                if (iTry <= iInf) { iTry = iInf+1; }
                assert(iTry <= iLim, "bug");

                /* Locate {jInf,jLim} near {iTry} s.t. */
                /* {iInf <= jInf < jLim <= iLim} and */
                /* {f[jInf] < z <= f[jLim}}: */
                int jInf = iTry-1; int jLim = iTry; int d = 1;
                fprintf(stderr, "!<%d:%d>", jInf,jLim);
                while ((jInf > iInf) && (f[jInf] >= z)) 
                  { jLim = jInf; 
                    jInf -= d; if (jInf < iInf) { jInf = iInf; }
                    d += d;
                    fprintf(stderr, "-");
                    fprintf(stderr, "!<%d:%d>", jInf,jLim);
                  }
                while ((jLim < iLim) && (f[jLim] < z)) 
                  { jInf = jLim; 
                    jLim += d; if (jLim > iLim) { jLim = iLim; }
                    d += d;
                    fprintf(stderr, "+");
                    fprintf(stderr, "!<%d:%d>", jInf,jLim);
                  }
                iInf = jInf; iLim = jLim;
                if ((iDif = iLim - iInf) <= 1) { break; }
              }
            
            /* Select a probe index {iMed} in {iInf+1..iLim-1}: */
            int iMed = (iInf + iLim)/2;
            fprintf(stderr, "?%d", iMed);
            assert(iInf < iMed, "bug");
            assert(iMed < iLim, "bug");
            /* Now do a bisection step: */
            if (f[iMed] < z)
              { iInf = iMed; fprintf(stderr, ">"); }
            else
              { iLim = iMed; fprintf(stderr, "<"); }
          }
        k = iLim;
        fprintf(stderr, "=%d=(", k); 
        if (k <= 0) { fprintf(stderr, "-oo"); } else { fprintf(stderr, "%3f", f[k-1]); } 
        fprintf(stderr, "_"); 
        if (k >= n) { fprintf(stderr, "+oo"); } else { fprintf(stderr, "%3f", f[k]); }  
        fprintf(stderr, "]]\n"); 
      }
    return k;
  }
----------------------------------------------------------------------
/* CHOOSING AND FINDING LEVELS */
  
void pswr_create_uniform_levels
  ( double fMin,    /* Minimum value. */
    double fMax,    /* Maximum value. */
    double fStep,   /* Spacing between levels. */
    double fSync,   /* Synchronize levels with this value. */
    int *nP,        /* (OUT) Number of levels. */
    double **fP     /* (OUT) Levels. */
  );
  /* Computes the set of all real levels that lie in the closed
    interval {[fMin __ fMax]} and are congruent to {fSync} modulo
    {fStep}. The count of those levels is returned in {*nP}, and the
    values (in ascending order) are returned in {(*fP)[0..(*nP)-1]}. The
    vector {(*fP)} is (re)allocated if needed, with {realloc}. */

int pswr_find_level(double z, int n, double *f);
  /* Assumes that levels {f[0..n-1]} are sorted in strictly increasing
    order. Returns the smallest index {k} in {0..n-1} such that
    {z <= f[k]}. If there is no such element, returns {k = n}. */

void pswr_find_isoline_indices
  ( double fMin, double fMax, 
    int n, 
    double *f, 
    int *kMin, 
    int *kMax
  );
  /* Assumes {n > 0} and that values {f[0..n-1]} are strictly
    increasing.  
    
    Returns in {kMin} the smallest index in {0..n-1} such that 
    {fMin <= f[kMin]}; or {kMin = n} if there is no such index. 
    
    Returns in {kMax} the largest index in {0..n-1} such that 
    {f[kMax] <= fMax}; or {kMax = -1} if there is no such index.
    
    Thus, if {kMin <= kMax}, then {kMin} and {kmax} are in {0..n-1},
    and {f[kMin]..f[kMax]} is the set of all {f} elements that lie in 
    the closed interval {F = [fMin __ fMax]}.  Otherwise {kMin = kMax + 1},
    and the {F} interval is wholly contained in the open
    interval {(f[kMax] __ f[kMin])}. */

void pswr_find_band_indices
  ( double fMin, double fMax, 
    int n, 
    double *f, 
    int *kMin, 
    int *kMax
  );
  /* Assumes that values {f[0..n-1]} are strictly increasing.  
    
    Returns in {kMin} the smallest index in {0..n-1} such that 
    {fMin < f[kMin]}; or {kMin = n} if there is no such index. 
    
    Returns in {kMax} the largest index in {1..n} such that 
    {f[kMax-1] < fMax}; or {kMax = 0} if there is no such index.
    
    Thus, we always have {0 <= kMin <= kMax <= n}, and
    {kMin..kMax} are the indices of all color bands which
    intersect the open interval {(fMin __ fMax)}. */

----------------------------------------------------------------------
void pswr_create_uniform_levels
  ( double fMin,    /* Minimum value. */
    double fMax,    /* Maximum value. */
    double fStep,   /* Spacing between values. */
    double fSync,   /* Synchronize values with this value. */
    int *nP,        /* (OUT) Number of values. */
    double **fP     /* (OUT) Values. */
  )
  { double *f = (*fP);
    int kMin, kMax;
    if ((fStep > 0.0) && (fMin <= fMax))
      { /* Sanity check to avoid excessive plotting: */
        assert((fMax - fMin) < fStep * MaxLevels, "too many levels");
        /* Find range of isoline numbers: */
        kMin = (int)(ceil((fMin - fSync)/fStep));
        kMax = (int)(floor((fMax - fSync)/fStep));
      }
    else
      { kMin = 0; kMax = -1; }
      
    /* (re)allocate table and fill it with levels: */
    int n = (kMax < kMin ? 0 : kMax - kMin + 1);
    f = realloc(f, n*sizeof(double));
    int k;
    for (k = kMin; k <= kMax; k++) 
      { f[k - kMin] = fSync + ((double)k) * fStep; }
    (*fP) = f;
    (*nP) = n;
  }

int pswr_nfinds = 0;
int pswr_nprobes = 0;

int pswr_find_level(double z, int n, double *f)
  {
    int k;
    if (n == 0) 
      { k = 0; }
    else if (z <= f[0])
      { k = 0; }
    else if (f[n-1] < z)
      { k = n; }
    else 
      { /* Answer is in {1..n-1}. Try to use {*k} as hint. */
        int iInf = 0, iLim = n-1; 
        pswr_nfinds++;
        
        /* Now narrow the interval by bisection or interpolation: */
        int iDif;
        while ((iDif = iLim - iInf) > 1)
          { /* Now {f[iInf] < z <= f[iLim]} hence {iInf < iLim}. */
            /* So the answer lies in {iInf+1..iLim}. */
           
            /* Use linear interpolation to narrow the interval {iInf+1..iLim}: */
            if (iDif >= 3)
              { /* Interpolate an index {iTry} in {iInf+1..iLim}: */
                int iTry;
                double r = (z - f[iInf])/(f[iLim] - f[iInf]);
                iTry = iInf + (int)(ceil(r*iDif));
                if (iTry <= iInf) { iTry = iInf+1; }
                assert(iTry <= iLim, "bug");
                pswr_nprobes += 2;

                /* Locate {jInf,jLim} near {iTry} s.t. */
                /* {iInf <= jInf < jLim <= iLim} and */
                /* {f[jInf] < z <= f[jLim}}: */
                int jInf = iTry-1; int jLim = iTry; int d = 1;
                while ((jInf > iInf) && (f[jInf] >= z)) 
                  { pswr_nprobes++;
                    jLim = jInf;
                    jInf -= d; if (jInf < iInf) { jInf = iInf; }
                    d += d;
                  }
                pswr_nprobes++;
                while ((jLim < iLim) && (f[jLim] < z)) 
                  { pswr_nprobes++;
                    jInf = jLim; 
                    jLim += d; if (jLim > iLim) { jLim = iLim; }
                    d += d;
                  }
                pswr_nprobes++;
                iInf = jInf; iLim = jLim;
                if ((iDif = iLim - iInf) <= 1) { break; }
              }
            
            /* Select a probe index {iMed} in {iInf+1..iLim-1}: */
            int iMed = (iInf + iLim)/2;
            assert(iInf < iMed, "bug");
            assert(iMed < iLim, "bug");
            /* Now do a bisection step: */
            if (f[iMed] < z)
              { iInf = iMed; }
            else
              { iLim = iMed; }
            pswr_nprobes++;
          }
        k = iLim;
      }
    return k;
  }

void pswr_find_isoline_indices
  ( double fMin, double fMax, 
    int n, 
    double *f, 
    int *kMin, 
    int *kMax
  )
  {
    int iMin = *kMin, iMax = *kMax;
    if (n == 0) 
      { iMin = 0; iMax = -1; }
    else
      { 
        /* Find smallest {iMax} so that {fMax <= f[iMax]}: */
        iMax = pswr_find_level(fMax, n, f);
        assert((iMax >= 0) && (iMax <= n), "bug"); 
        
        /* Find smallest {iMin} so that {fMin <= f[iMin]}: */
        iMin = pswr_find_level(fMin, iMax, f);
        assert((iMin >= 0) && (iMin <= iMax), "bug"); 
        
        /* Reduce {iMax} so that {f[iMax] <= fMax} : */
        if ((iMax == n) || (f[iMax] > fMax)) { iMax--; }
        
        /* Sanity check to avoid excessive plotting: */
        int nIsolines = iMax - iMin + 1;
        if (nIsolines > MaxIsolinesInTriangle)
          { if (! pswr_isolines_complained) 
              { fprintf(stderr, "** too many isolines in triangle");
                fprintf(stderr, " fMin = %g  fMax = %g", fMin, fMax);
                pswr_isolines_complained = TRUE;
              }
            int excess = MaxIsolinesInTriangle - nIsolines;
            iMin = iMin + excess/2;
            iMax = iMin + MaxIsolinesInTriangle - 1;
          }
        else
          { assert(iMin == 0 ? TRUE : f[iMin - 1] < fMin, "bug");
            assert(iMax == n-1 ? TRUE : fMax < f[iMax + 1], "bug");
          }
        assert(iMin == n ? TRUE : fMin <= f[iMin], "bug");
        assert(iMax == -1 ? TRUE : f[iMax] <= fMax, "bug");
      }
    (*kMin) = iMin;
    (*kMax) = iMax;
  }

void pswr_find_band_indices
  ( double fMin, double fMax, 
    int n, 
    double *f, 
    int *kMin, 
    int *kMax
  )
  {
    int iMin = *kMin, iMax = *kMax;
    if (n == 0) 
      { iMin = 0; iMax = 0; }
    else
      { 
        /* Find smallest {iMax} so that {fMax <= f[iMax]}: */
        iMax = pswr_find_level(fMax, n, f);
        assert((iMax >= 0) && (iMax <= n), "bug"); 
        
        /* Find smallest {iMin} so that {fMin <= f[iMin]}: */
        iMin = pswr_find_level(fMin, iMax, f);
        assert((iMin >= 0) && (iMin <= iMax), "bug"); 
        
        /* Ensure {fMin < f[iMin]}: */
        if ((iMin < n) && (fMin == f[iMin])) { iMin++; }
        
        /* Sanity check to avoid excessive plotting: */
        int nIsolines = iMax - iMin;
        if (nIsolines > MaxIsolinesInTriangle)
          { if (! pswr_isolines_complained) 
              { fprintf(stderr, "** too many isolines in triangle");
                fprintf(stderr, " fMin = %g  fMax = %g", fMin, fMax);
                pswr_isolines_complained = TRUE;
              }
            int excess = MaxIsolinesInTriangle - nIsolines;
            iMin = iMin + excess/2;
            iMax = iMin + MaxIsolinesInTriangle;
          }
        else
          { assert(iMin == 0 ? TRUE : f[iMin - 1] <= fMin, "bug");
            assert(iMax == n ? TRUE : fMax <= f[iMax], "bug");
          }
        assert(iMin == n ? TRUE : fMin < f[iMin], "bug");
        assert(iMax == 0 ? TRUE : f[iMax - 1] < fMax, "bug");
      }
    (*kMin) = iMin;
    (*kMax) = iMax;
  }

----------------------------------------------------------------------

int pswr_num_isolines(double vStart, double vStep, double vMin, double vMax)
  {
    int kMin = pswr_next_isoline(vMin);
    int kMax = pswr_prev_isoline(vMax);
    int N = kMax - kMin + 1;
    assert(N >= 0, "bug");
    return N;
  }  
  
int pswr_num_bands(double vStart, double vStep, double vMin, double vMax)
  {
    int kMin = pswr_prev_isoline(vMin);
    int kMax = pswr_next_isoline(vMax);
    int N = kMax - kMin;
    assert(N >= 0, "bug");
    return N;
  }  
----------------------------------------------------------------------
void pswr_find_band_indices
  ( double fMin, double fMax, 
    int n, 
    double *f, 
    int *iMin, 
    int *iMax
  )
  {
    int iMin = *iMin, iMax = *iMax;
    if (n == 0) 
      { iMin = 0; iMax = 0; }
    else
      { 
        /* Find smallest {iMax} so that {fMax <= f[iMax]}: */
        iMax = pswr_find_level(fMax, n, f);
        assert((iMax >= 0) && (iMax <= n), "bug"); 
        
        /* Find smallest {iMin} so that {fMin <= f[iMin]}: */
        iMin = pswr_find_level(fMin, iMax, f);
        assert((iMin >= 0) && (iMin <= iMax), "bug"); 
        
        /* Ensure {fMin < f[iMin]}: */
        if ((iMin < n) && (fMin == f[iMin])) { iMin++; }
        
        /* Sanity check to avoid excessive plotting: */
        int nIsolines = iMax - iMin;
        if (nIsolines > MaxIsolinesInTriangle)
          { if (! pswr_isolines_complained) 
              { fprintf(stderr, "** too many isolines in triangle");
                fprintf(stderr, " fMin = %g  fMax = %g", fMin, fMax);
                pswr_isolines_complained = TRUE;
              }
            int excess = MaxIsolinesInTriangle - nIsolines;
            iMin = iMin + excess/2;
            iMax = iMin + MaxIsolinesInTriangle;
          }
        else
          { assert(iMin == 0 ? TRUE : f[iMin - 1] <= fMin, "bug");
            assert(iMax == n ? TRUE : fMax <= f[iMax], "bug");
          }
        assert(iMin == n ? TRUE : fMin < f[iMin], "bug");
        assert(iMax == 0 ? TRUE : f[iMax - 1] < fMax, "bug");
      }
    (*iMin) = iMin;
    (*iMax) = iMax;
  }

----------------------------------------------------------------------
Last edited on 2003-10-12 18:54:58 by stolfi
